<?php
# vim: set expandtab tabstop=2 shiftwidth=2 autoindent smartindent:
if(basename(__FILE__) == basename($_SERVER['PHP_SELF'])){
  exit();
}

// useful for debugging purposes
error_reporting(E_ERROR | E_WARNING | E_PARSE);

// Update include path
if (!defined('PATH_SEPERATOR')){
  define('PATH_SEPERATOR', ':');
}

if (!defined('DIRECTORY_SEPARATOR')){
  define('DIRECTORY_SEPARATOR','/');
}

if (!defined('BASE_URL')){
  define('BASE_URL', 'http://www.makingpublics.org');
}

function sysInit($basePath){
  define ('BASE_SYS_DIR', $basePath);

  ini_set('include_path', '.'
    . PATH_SEPERATOR . BASE_SYS_DIR 
    . PATH_SEPERATOR . BASE_SYS_DIR . DIRECTORY_SEPARATOR. 'includes'
    . PATH_SEPARATOR . BASE_SYS_DIR . DIRECTORY_SEPARATOR. 'classes'
    . PATH_SEPARATOR . BASE_SYS_DIR . DIRECTORY_SEPARATOR. 'lib'
    . PATH_SEPARATOR . ini_get('include_path')
  );

  // define our application directory
  define('APP_DIR', BASE_SYS_DIR);

  // define templates directory --
  define('APP_TMPL_DIR', BASE_SYS_DIR . DIRECTORY_SEPARATOR.'templates'); 

  session_name("mapssession");
  /*
  setcookie(session_name(), session_id(), 1, '/');
  if(!empty($_COOKIE['mapssession'])){
    session_id($_COOKIE['mapssession']);
  }
  */
  session_start();   
  $_SESSION['baseURL'] = BASE_URL;
  $_SESSION['appDIR'] = APP_DIR;
  $_SESSION['tmplDIR'] = APP_TMPL_DIR;
/*
  if (isset($_SESSION['HTTP_USER_AGENT']))
{
    if ($_SESSION['HTTP_USER_AGENT'] != md5($_SERVER['HTTP_USER_AGENT']))
    {
        // Prompt for password 
        exit;
    }
}
else
{
    $_SESSION['HTTP_USER_AGENT'] = md5($_SERVER['HTTP_USER_AGENT']);
}
*/
}

function import($class){
    require_once(str_replace('.', '/', $class) . 'inc.php');
}

function getBasePath(){
    return dirname(dirname(__FILE__));
}

function debugInfo($i){
  echo("--------". $i . "---------");
  print_r($_SESSION);
  print_r($_SERVER);
  echo("-- end --". $i . "--------");
}
function displayArray($array) {

	echo '<table border="2"><br>';

	foreach ($array as $key => $value) {

		echo '<tr><td><b>' . $key. '==></b></td>';
		echo '<td>';
		if (is_array($value)){
			displayArray($value);
		}else{
			if (empty($value)){
				echo 'empty';
			}else{
				echo $value;
			}
		}
		echo '</td></tr>';
		echo '<br>';
	}
	echo '</table>';

	return;

}

function multi_array_search($search_value, $the_array)
{
   if (is_array($the_array))
   {
       foreach ($the_array as $key => $value)
       {
           $result = multi_array_search($search_value, $value);
           if (is_array($result))
           {
               $return = $result;
               array_unshift($return, $key);
               return $return;
           }
           elseif ($result == true)
           {
               $return[] = $key;
               return $return;
           }
       }
       return false;
   }
   else
   {
       if ($search_value == $the_array)
       {
           return true;
       }
       else return false;
   }
}
?>
