<?php include("../../../frame/pieces/phpheader.php"); ?>
<html>
<head>
<meta name="description" content="Making Publics is a research community dedicated to exploration of public life, publicity, and forms of association in early modern European cultures and societies. Growing out of a highly successful international research project based at McGill University in Montreal, our online community provides scholars the tools to build historical social networks, collate and integrate research data from various online sources with their ongoing research, and make it all reusable and accessible to a wider audience through linked open data." />
<meta name="keywords" content="Early Modern Europe, Early Modern Publicity, Publicity, Early Modern, Renaissance, Public Life, Public Sphere, Renaissance Europe, Reformation Europe, Networks, Public Networks, History of Public Life, European Public Life, Sixteenth Century Europe, Seventeenth Century Europe, Forms of Association, Association" />
<title>Making Publics - Network Webs</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style>
#viewer{
width:96%;
height:96%;
display:block;
margin:auto;
}
#content-visualization{
width:100%;
height:100%;
display:block;
}
body {
    font: 0.8em/1.8 'Source Sans Pro','Tahoma',sans-serif;
    height: 100%;
    margin: 0;
    padding: 0;
    width: 100%;
    background-color:#CADEF9;
    color: #000000;
    letter-spacing: 0.1em;
}
</style>
<link href='http://fonts.googleapis.com/css?family=Source+Sans+Pro|Libre+Baskerville&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
    <!--[if IE 7]>
      <link type="text/css" rel="stylesheet" media="all" href="http://www.makingpublics.org/frame/css/ie7.css" />
    <![endif]-->

    <!--[if lte IE 6]>
      <link type="text/css" rel="stylesheet" media="all" href="http://www.makingpublics.org/frame/css/ie6.css" />
    <![endif]-->

    <!--[if lte IE 6]>
      <script type="text/javascript">
        $(document).ready(function(){
          $(document).pngFix();
        });
      </script>
    <![endif]-->
        <!--[if lte IE 6]>
      <script type="text/javascript">
        $(document).ready(function(){
          $(document).pngFix();
        });
      </script>
    <![endif]-->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js"></script>
<script type="text/javascript" src="http://d3js.org/d3.v3.js"></script>

<script type="text/javascript">

$.extend({
    distinct : function(anArray) {
       var result = [];
       $.each(anArray, function(i,v){
           if ($.inArray(v, result) == -1) result.push(v);
       });
       return result;
    }
});

var showobject;
var that = this;
var nodesj = [], linksj = [], nodes = [], links = [];
var typelist = [], placelist = [], earliestdate, latestdate;
var focicall = "base", //possible base, type, place, date, timeline, map
foci = [], basefoci = [], typefoci = [], placefoci = [], datefoci = [], timelinefoci = [], geofoci = [];
var colourcall = "date"; //possible type, place, date
//tag bundle
//var bundledata = [];

var geodata = d3.entries({
	"madera": [-120.12, 36.98]
,"sanjose": [-121.92, 37.37]
,"merced": [-120.50, 37.28]
,"atwater": [-120.57, 37.37]
,"americancanyon": [-122.28, 38.20]
,"fairfield": [-121.95, 38.27]
,"sancarlos": [-122.25, 37.52]
});

var color = d3.scale.category10();

$(function() {
	loadjson();
	$('#datasetterms').val('<?php print $_SERVER["QUERY_STRING"];?>');
});

function loadjson () {
	$.ajax({
		<?php if($_GET['q']){?>
		type:'GET',
		url: "http://www.makingpublics.org/frame/ajax/data/webs.php",
		dataType: 'text',
		data: {q:'<?php print $_GET['q'];?>'<?php if($_GET['d']){
		print ",d:'".$_GET['d']."'";
		}
		if($_GET['nt']){
		print ",nt:'".$_GET['nt']."'";
		}
		if($_GET['e']){
			print ",e:'".$_GET['e']."'";
		}
		if($_GET['c']){
		print ",c:'".$_GET['c']."'";
		}?>},
		success: function(data){
			$('#thisdataset').val(data);
$('#filedata').val(data);
			showobject = jQuery.parseJSON(data);
			<?php }else{?>

			url: "http://www.makingpublics.org/frame/ajax/content/datasets.php?j=g",
		dataType: 'text',
		data: {id:'<?php print $_GET['data'];?>'},
		success: function(data){
			var dataset = jQuery.parseJSON(data);
			showobject = jQuery.parseJSON(dataset.dataset);
$('#filedata').val(dataset.dataset);
			$('#datasettitle').text(dataset.datasetname);
			$('#datasetowner').text(dataset.ownerid);
			$('#datasetmade').text(dataset.madedate);
			$('#corenodes').text(dataset.queryterms);
			$('#datasetdescription').text(dataset.datadescription);
			<?php }?>
		},
		error: function(){
			alert("There was an error loading the JSON.");
		},
		complete: function(){
			if(showobject.nodes){
			buildjsondata();
			setTimeout(function(){initvisualization();},500);
			$("#historicalnetworkmap").hide();
			}else{
			$("#content-visualization").empty();
			$("#content-visualization").html("<h4>There are no nodes! search again!</h4>");
			}
		}
	});
}

function findnodebyid(id, listofnodes){
	var index;
	var len = listofnodes.length;
	for(var k = 0; k < len; k++){
		if(listofnodes[k].id == id){
			index = k;
		}
	}
	return index;
}

function buildjsondata() {
	var jsonnodes = showobject.nodes,
	jsonlinks = showobject.events,
	jsonedges = showobject.edges;

	var removearray = [];

	//this removes all the literals from the JSON data
	for(var k = jsonnodes.length - 1; k >= 0; k--){
		if(jsonnodes[k].type == '1'){
			for(var l = 0; l < jsonlinks.length; l++){
				if(jsonnodes[k].name == jsonlinks[l].node1name || jsonnodes[k].name == jsonlinks[l].node2name){
					jsonlinks.splice(l,1);
				}
			}
			jsonnodes.splice(k,1);
		}
	}

	edges = [];
	for (var e = 0; e < jsonedges.length; e++) {
		edges.push(jsonedges[e].edge);
	}
	var distinctedges=$.distinct(edges);
	console.log(distinctedges);
	var alledges=distinctedges.join();
	$('#foundedges').text(alledges);

	nodes = [];
	links = [];
	for (var z = 0; z < jsonnodes.length; z++) {
		//var nodelocation = haslocation(jsonnodes[z]);
		nodes.push({
			name: jsonnodes[z].name,
			//location: nodelocation,
			id: 'idt' + jsonnodes[z].type + 'n' + jsonnodes[z].id,
			type: jsonnodes[z].type
		});
		//tag bundle
		/*bundledata.push({name:jsonnodes[z].name,
			size: z,
			import: []
		});*/
		//manageearliestdate(nodelocation);
		//managelatestdate(nodelocation);
		//managetypelist(jsonnodes[z].type);
		//manageplacelist(nodelocation);
	}
	//basefoci = generatefoci(0);
	//typefoci = generatefoci(typelist.length);
	//placefoci = generatefoci(placelist.length);
	//datefoci = generatefoci(20);
	//timelinefoci = generatetimeline(20);
	//foci = basefoci;
	for (var z = 0; z < jsonlinks.length; z++) {
		links.push({
			name: jsonlinks[z].name,
			id: 'idt' + jsonlinks[z].node1type + 'n' + jsonlinks[z].node1id + '-' + 'idt' + jsonlinks[z].node2type + 'n' + jsonlinks[z].node2id,
			source: findnodebyid('idt' + jsonlinks[z].node1type + 'n' + jsonlinks[z].node1id, nodes),
			target: findnodebyid('idt' + jsonlinks[z].node2type + 'n' + jsonlinks[z].node2id, nodes),
			node1name: jsonlinks[z].node1name,
			node1id: 'idt' + jsonlinks[z].node1type + 'n' + jsonlinks[z].node1id,
			node2name: jsonlinks[z].node2name,
			node2id: 'idt' + jsonlinks[z].node2type + 'n' + jsonlinks[z].node2id,
			edgename: jsonlinks[z].edge,
			edgeid: 'id' + jsonlinks[z].edgeid,
			eventid: jsonlinks[z].eventid
		});
		//tag bundle
		/*var lena = bundledata.length;
		for(var j = 0; j < lena; j++){
			if(bundledata[j].name == jsonlinks[z].node1name) bundledata[j].import.push(jsonlinks[z].node2name);
		}*/
	}
}


function initvisualization(){
var width = $('#content-visualization').width();
    height = $('#content-visualization').height();

var force = d3.layout.force()
    .nodes(d3.values(nodes))
    .links(links)
    .size([width, height])
    .linkDistance(80)
    .charge(-300)
    .on("tick", tick)
    .start();

var svg = d3.select("#content-visualization").append("svg:svg")
    .attr("width", width)
    .attr("height", height)
    .style({"position": "relative"});

// build the arrow.
svg.append("svg:defs").selectAll("marker")
    .data(["end"])
  .enter().append("svg:marker")
    .attr("id", String)
    .attr("viewBox", "0 -5 10 10")
    .attr("refX", 15)
    .attr("refY", -1.5)
    .attr("markerWidth", 6)
    .attr("markerHeight", 6)
    .attr("orient", "auto")
    .style({'fill': '#888'})
  .append("svg:path")
    .attr("d", "M0,-5L10,0L0,5");

// add the links and the arrows
var path = svg.append("svg:g").selectAll("path")
    .data(force.links())
  .enter().append("svg:path")
  	.style({'fill': 'none'})
  	.style({'stroke': '#888'})
  	.style({'stroke-width': '1.5px'})
    .attr("marker-end", "url(#end)");

// define the nodes
var node = svg.selectAll(".node")
    .data(force.nodes())
  .enter().append("g")
    .attr("class", "node")
    .call(force.drag);

// add the nodes
node.append("circle")
    .attr("r", 5)
    .style("fill", function(d) { return color(d.type); })
    .style({'stroke': '#fff'})
    .style({'stroke-width': '1.5px'});

// add the text
node.append("text")
    .attr("x", 12)
    .attr("dy", ".35em")
    .text(function(d) { return d.name; })
    .style({'fill': '#000'})
    .style({'font': '10px sans-serif'})
    .style({'pointer-events': 'none'});

// add the curvy lines
function tick() {
    path.attr("d", function(d) {
        var dx = d.target.x - d.source.x,
            dy = d.target.y - d.source.y,
            dr = Math.sqrt(dx * dx + dy * dy);
        return "M" +
            d.source.x + "," +
            d.source.y + "A" +
            dr + "," + dr + " 0 0,1 " +
            d.target.x + "," +
            d.target.y;
    });

    node
        .attr("transform", function(d) {
            return "translate(" + d.x + "," + d.y + ")"; });
}

}


</script>
</head>
<body>
<div id="viewer">
<strong>Query</strong>
<span id="corenodes"><?php
if($_GET['q']){
$thesecores=$_GET['q'];
$cores=explode(',',$thesecores);
$c=0;
foreach($cores as $core){
$thiscore=explode(':',$core);
switch($thiscore[0]){
case "person";
$corename[$c]=personnamebuild('l',$thiscore[1],'n');
break;
case "literal";
//$corename[$c]=;
break;
case "thing";
$corename[$c]=thingbuild('e',$thiscore[1]);
break;
case "event";
$corename[$c]=eventnamebuild("l",$thiscore[1]);
break;
case "place";
$corename[$c]=placenamebuild("l",$thiscore[1],'n');
break;
case "organization";
$corename[$c]=organizationbuild("l",$thiscore[1]);
break;
}
$c++;
}
$allcores=implode('] + [',$corename);
print "[".$allcores."]";
}?></span>
<strong>Verbs</strong>
<span id="foundedges"></span>
<div id="content-visualization"></div>
</div>
</body>
</html>